.TH DIRED 1 "01 July 1998" "Version 3.00"
.\"=====================================================================
.SH NAME
dired \- file directory editor
.\"=====================================================================
.SH SYNOPSIS
.B dired
[
.BI \-g "[gid-or-groupname]"
]
[
.BR \- [ s|r ][ cnsrw ]
]
.if n .ti +\w'\fBdired\fP\ 'u
[
.BI \-u "[uid-or-username]"
]
[
.B \-v
]
[
.BR \-w [ f|h|number ]
]
.if n .ti +\w'\fBdired\fP\ 'u
.if t .ti +\w'\fBdired\fP\ 'u
[
.IR directory-list | file-list
]
.\"=====================================================================
.SH DESCRIPTION
.B dired
displays a long-form
.BR ls (1)
directory listing on the screen of a display terminal and allows you
to `edit' and peruse that listing by moving up and down, deleting,
undeleting, editing, and displaying entries.  The
.BR emacs (1)
text editor provides a similar capability in an editor window.
The shell
.I TERM
variable should be set to the standard
string which the Berkeley
.I termcap
library uses for distinguishing terminals.  With no argument, the
connected directory is used.  With only one argument, if that argument
is a directory, it is used.  With multiple arguments, (or a single
non-directory argument) the argument(s) are interpreted as filenames.
.B dired
then types `Reading' and gets information about the various
files/directories in your specification.  This may take a short while
(depending on how many you give it), so it types one period (.) after
the word `Reading' for
every 10 files it has gathered information about.  With this, you
can keep track of its progress.  Interrupts, hangups, and the like
are disabled since your terminal is put into a special mode that
is only changed when you quit with the
.I q
command.
.PP
The format of the screen is as follows: each line represents a file (or
directory), the name of which is right-most.  From left the fields
are: mode, link count, owner, size, write date and name.  See
.BR ls (1)
for a description of what each of these mean.  You move up and down
the column immediately left of the filename.  The bottom
half of the screen is used for displaying files via the
.BR t ype
command.
If there are too many files to all fit on one window, more windows
are allocated.  The
.B f
and
.B b
commands can be used for stepping forward
and backward windows.
The last screen line is used as an `echo' line for displaying error messages
and reading arguments.
It also displays the full directory name if `direding' a directory.
When in split screen mode, the divider serves also as a `linear indicator'
showing where the
current window is relative to the entire list of files.
The symbols `(' and `)' denote the window.  Square brackets
replace `(' and/or `)' when the window is the first and/or last window.
A single `o' is used to represent the window when the window size is small
compared to the total number of
files.
.\"=====================================================================
.SH OPTIONS
Command-line options, which are inherited by recursive invocations of
.BR dired ,
are:
.\"---------------------------------------------------------------------
.TP
.BI \-g "[gid-or-groupname]"
Show only files belonging to the specified group id number or group
name.  If the number or name is omitted, then the group id of the
current user is assumed.
.\"---------------------------------------------------------------------
.TP
.B \-[sr][c|n|s|r|w]
Forward or reverse sort by
.IR "creation date" ,
.IR name ,
.IR size ,
.IR "read date" ,
or
.I "write date"
respectively.  ``Normal sort'' is the order most often desired; it is
largest first for size, and most recent for read and write date sorts.
The default is to sort by name.
.\"---------------------------------------------------------------------
.TP
.BI \-u "[uid-or-username]"
Show only files belonging to the specified user id number or user
name.  If the number or name is omitted, then the user id of the
current user is assumed.
.\"---------------------------------------------------------------------
.TP
.B \-v
Show the program version on
.IR stderr ,
and quit immediately.
.\"---------------------------------------------------------------------
.TP
.B \-w[f|h|number]
Use
.B number
lines for the directory index window, reserving the other half for quick
file display.
.B f
means use the full screen for the index.
.B h
means use half of the screen for the index.
.B h
is the default.
.\"=====================================================================
.SH "KEYBOARD COMMANDS"
.PP
Commands consist of single characters, with any necessary arguments
prompted for, and displayed in the echo line.  Several commands take
an optional non-negative integer count argument, as in
.BR vi (1).
.PP
Here are the keyboard commands that control
.BR dired ,
organized into several categories:
.\"*********************************************************************
.PP
.B "Help"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.BR ? , " h"
Display a help message summarizing the keyboard commands.
.RE
.\"*********************************************************************
.PP
.B "Quitting dired"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.B a
Abort out of the current directory.  No deletions are done.
.\"---------------------------------------------------------------------
.TP
.B A
Abort completely out of
.BR dired ,
with no deletions.
.\"---------------------------------------------------------------------
.TP
.B q
Exit
.BR dired ,
displaying files marked for deletion and requiring confirmation before
deleting them.  If no confirmation is given (typing anything other
than
.IR y ),
.B dired
goes back to its display.
.\"---------------------------------------------------------------------
.TP
.B Q
Quit
.BR dired ,
with no deletions.
.RE
.\"*********************************************************************
.PP
.B "Actions on files"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.B !
Prompt for a system command to invoke.  The command is executed,
and confirmation is required before returning to the display.
All
.B %
characters in the command are replaced with the full pathname of the current
entry, and all
.B #
chars are replaced with just the trailing filename component
(what you see on the screen).
.\"---------------------------------------------------------------------
.TP
.B .
Repeat the previous
.B !
shell command, substituting the current entry for any special chars (%#)
in the original command.
.\"---------------------------------------------------------------------
.TP
.B e
Run the editor defined in the
.I EDITOR
environment variable
upon the current file.  If
.I EDITOR
is not defined,
.BR vi (1)
is used.
However, if the current
file is a directory, it is not edited, but rather,
.B dired
forks a copy of itself upon that directory.  In this manner, you can
examine the contents of that directory and thus move down the
directory hierarchy.
.\"---------------------------------------------------------------------
.TP
.B m
Run the program defined by the
.I PAGER
environment variable program on the current entry.  If
.I PAGER
is not defined, run
.BR more (1).
.\"---------------------------------------------------------------------
.TP
.B P
Print the current file on the lineprinter.
.\"---------------------------------------------------------------------
.TP
.B t
Type the file to the terminal; this is considerably faster than
starting an editor on the file.  In two-window mode, the bottom window
is used, pausing after each screenful.  The type-out may be
interrupted by
.B <control C>
or
.BR q .
.\"---------------------------------------------------------------------
.TP
.B T
Same as
.BR t ,
but without any pauses at end-of-screen.
.RE
.\"*********************************************************************
.PP
.B "Deletion and undeletion"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.B d
Mark the current entry for deletion.  Upon exit and confirmation
(or re-reading using the
.B `R'
command), this entry will be deleted.
.I Warning:
this includes directories!
If it is a directory, everything in it and underneath it will be
removed.
.\"---------------------------------------------------------------------
.TP
.B D
Mark
.I all
files for deletion.
.RB ( `U'
undoes this).
.\"---------------------------------------------------------------------
.TP
.B ~
Mark files with names ending in ~ for deletion.
.\"---------------------------------------------------------------------
.TP
.B #
Mark files with names beginning with # for deletion.
.\"---------------------------------------------------------------------
.TP
.B u
Undelete the current entry, if it was previously marked for deletion.
.\"---------------------------------------------------------------------
.TP
.B U
Cancel all deletion requests.
.RE
.\"*********************************************************************
.PP
.B "Display"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.B <space>
Re-print the directory path name.
.\"---------------------------------------------------------------------
.TP
.B c
Refresh the current line.
.\"---------------------------------------------------------------------
.TP
.B \e
Toggle between split-screen mode and full-screen mode.
.\"---------------------------------------------------------------------
.TP
.B "<control G>"
Show the current file number, the total number of files, and the
percentage through the file.  Useful in full screen mode when there is no
linear indicator.
.\"---------------------------------------------------------------------
.TP
.BR l , " <control L>"
Refresh the current window.
.\"---------------------------------------------------------------------
.TP
.B p
Display the full path name of the current file; embedded control
characters are shown with graphics.
.\"---------------------------------------------------------------------
.TP
.B R
Re-read the directory or file list.  If files are marked for deletion,
.B dired
will first ask for confirmation and then delete them before re-reading.
This is useful after operations done during shell escapes (e.g.
.BR chmod (1)).
.\"---------------------------------------------------------------------
.TP
.BR r , " s"
Sort the file list by various fields: creation date, name, read date,
size, write
date.  Only the first letter (e.g.
.BR c ,
.BR n ,
.BR r ,
.BR s ,
or
.BR w )
is required after
giving the
.B r
and
.B s
commands.
.B s sorts in increasing alphabetic, decreasing
size, newest to oldest dates.
.B r
reverses the sense of
.BR s .
For the
.BR n ,
.BR s ,
and
.B w
subcommands, the date field is the write date.  For
the
.B r
subcommand, the date field is the read date.  Whenever a sort
is done, you are positioned at the top of the list afterwards.
A sort can be aborted via
.BR <ESC> .
.RE
.\"*********************************************************************
.PP
.B "Miscellaneous"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.B <ESC>
Cancel a sort or a count.
.RE
.\"*********************************************************************
.PP
.B "Moving around"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.BR "<down arrow>" , " <lf>" , "^N" , " j"
Step to the next file.  If this crosses a window boundary, the next
window is displayed with a one-line overlap.  May be preceded by a
count.
.\"---------------------------------------------------------------------
.TP
.BR "<up arrow>" , " ^" , " -" , " k" , " <backspace>" , " ^P"
Step to previous file.  If this crosses a window boundary, the
previous window is displayed with a one-line overlap.  May be preceded by
a count.
.\"---------------------------------------------------------------------
.TP
.BR "<PageDown>" , " <right arrow>" , " f"
Go forward a window, leaving a one-line overlap.  May be preceded by a
count.
.\"---------------------------------------------------------------------
.TP
.BR "<PageUp>" , "<left arrow>" , " b"
Go backward a window, leaving a one-line overlap.  May be preceded by a
count.
.\"---------------------------------------------------------------------
.TP
.BR < , " [" , " (" , " {"
Go to the start of the file list.  With an argument
.IR n ,
go
.I n/10
of the way from the start.
.\"---------------------------------------------------------------------
.TP
.BR > , " ]" , " )" , " }"
Go to the end of the file list.  With an argument
.IR n ,
go
.I n/10
of the way from the end.
.\"---------------------------------------------------------------------
.TP
.B E
Go up to the next higher level directory.  In the case of an
argument list of files to
.BR dired ,
go to the parent of the directory which contains the current file.
.\"---------------------------------------------------------------------
.TP
.B G
Go to the file number given by the preceding count.  With no count,
go to the last file as in
.BR vi (1).
.\"---------------------------------------------------------------------
.TP
.B M
Remember the current entry on the mark stack.  You can later return to
it with the
.B J
(jump) command.
.\"---------------------------------------------------------------------
.TP
.B J
Pop the top entry from the mark stack, and jump to it.
.\"---------------------------------------------------------------------
.TP
.B L
Pop the top entry from the view stack, and jump to it.  Each screen
display adds an entry to the view stack, except for views created by
this command, so you can use
.B L
to display views in reverse order.
.RE
.\"*********************************************************************
.PP
.B "Searching"
.RS
.\"---------------------------------------------------------------------
.TP \w'MMMMMM'u+2n
.BR / <regular-expression>
Locate a file matching the given regular expression, as defined in
.BR re_comp (3)
and
.BR re_exec (3).
The search is in the forward direction.  The regular expression is
remembered for subsequent use by the
.B n
and
.B N
commands.  If the regular expression is empty, the last one remembered
is used.
.\"---------------------------------------------------------------------
.TP
.B n
Find the next instance in the forward direction of the regular
expression previously-defined by a
.I `/'
command.
.\"---------------------------------------------------------------------
.TP
.B N
Find the next instance in the backward direction of the regular
expression previously-defined by a
.I `/'
command.
.RE
.\"=====================================================================
.SH DIAGNOSTICS
The error messages should be self-explanatory.
.PP
The exit codes returned to the invoking program are as follows:
.RS
.TP
.B 0
success (normal termination)
.TP
.B 1
failure (usually accompanied by an explanatory message)
.TP
.B 2
failed to open \fCtermcap\fP file
.TP
.B 3
unknown terminal type
.TP
.B 69
user requested abort with
.I A
or
.IR Q ,
or else editor invocation failed
.RE
.\"=====================================================================
.SH FILES
.TP \w'\fI/usr/local/bin/dired.hlp\fP'u+3n
.I /usr/local/bin/dired
Executable program.
.TP
.I /usr/local/src/dired
Source directory.
.TP
.I /usr/local/bin/dired.hlp
Help file for
.B ?
and
.BR h .
.\"=====================================================================
.SH "SEE ALSO"
.BR emacs (1),
.BR ls (1).
.BR more (1),
.BR re_comp (3),
.BR re_exec (3),
.BR vi (1).
.\"=====================================================================
.SH AUTHORS
Stuart Mclure Cracraft.
.br
Enhancements by Jay Lepreau <lepreau@cs.utah.edu>.
.br
Fixes and enhancements by Charles Hill.
.br
More fixes and enhancements, and major revision of manual pages, by
Nelson H. F. Beebe <beebe@math.utah.edu>, who is the current
maintainer of
.BR dired .
.ad
.br
Regular-expression support code by Tatu Ylonen <ylo@ngs.fi>.
.\"=====================================================================
.SH AVAILABILITY
.B dired
is freely available; its master distribution can
be found at
.PP
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/misc\fP
.fi
.RE
.PP
in the file
.I dired-x.yy.tar.gz
where
.I x.yy
is the current version.  Other distribution
formats are usually available in the same
location.
.PP
That site is mirrored to several other Internet
archives, so you may also be able to find it
elsewhere on the Internet; try searching for the
string
.I dired
at one or more of the popular Web search sites,
such as
.PP
.RS
.nf
\&\fChttp://altavista.digital.com/
http://www.hotbot.com/
http://www.stpt.com/
http://www.yahoo.com/\fP
.fi
.RE
.\"=====================================================================
.SH BUGS
Long lines sometimes screw up the
.B t
(type) display.
.br
@@@ gam Sun Apr 1  8:00:11 PM PST 1984 original version
